"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _assign = _interopRequireDefault(require("@babel/runtime/core-js/object/assign"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var actions = _interopRequireWildcard(require("./actions"));

var _constants = require("./constants");

var _get_hash = _interopRequireDefault(require("./get_hash"));

var _connect_resolve_advanced = _interopRequireDefault(require("./connect_resolve_advanced"));

var connectReadModel = function connectReadModel(mapStateToOptions) {
  return function (Component) {
    var ReadModelContainer =
    /*#__PURE__*/
    function (_React$PureComponent) {
      (0, _inherits2.default)(ReadModelContainer, _React$PureComponent);

      function ReadModelContainer() {
        (0, _classCallCheck2.default)(this, ReadModelContainer);
        return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ReadModelContainer).apply(this, arguments));
      }

      (0, _createClass2.default)(ReadModelContainer, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          var _this$props$connector = this.props.connectorOptions,
              readModelName = _this$props$connector.readModelName,
              resolverName = _this$props$connector.resolverName,
              resolverArgs = _this$props$connector.resolverArgs,
              isReactive = _this$props$connector.isReactive;
          this.props.connectReadModel(readModelName, resolverName, resolverArgs, isReactive);
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          var _this$props$connector2 = this.props.connectorOptions,
              readModelName = _this$props$connector2.readModelName,
              resolverName = _this$props$connector2.resolverName,
              resolverArgs = _this$props$connector2.resolverArgs,
              isReactive = _this$props$connector2.isReactive;
          this.props.disconnectReadModel(readModelName, resolverName, resolverArgs, isReactive);
        }
      }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate(prevProps) {
          var connectorOptions = this.props.connectorOptions;
          var prevConnectorOptions = prevProps.connectorOptions;

          if (connectorOptions && prevConnectorOptions && (prevConnectorOptions.readModelName !== connectorOptions.readModelName || prevConnectorOptions.resolverName !== connectorOptions.resolverName || prevConnectorOptions.resolverArgs !== connectorOptions.resolverArgs) && (prevConnectorOptions.readModelName !== connectorOptions.readModelName || prevConnectorOptions.resolverName !== connectorOptions.resolverName || (0, _get_hash.default)(prevConnectorOptions.resolverArgs) !== (0, _get_hash.default)(connectorOptions.resolverArgs))) {
            this.props.disconnectReadModel(prevConnectorOptions.readModelName, prevConnectorOptions.resolverName, prevConnectorOptions.resolverArgs, prevConnectorOptions.isReactive);
            this.props.connectReadModel(connectorOptions.readModelName, connectorOptions.resolverName, connectorOptions.resolverArgs, connectorOptions.isReactive);
          }
        }
      }, {
        key: "render",
        value: function render() {
          var _this$props = this.props,
              ownProps = _this$props.ownProps,
              isLoading = _this$props.isLoading,
              data = _this$props.data;

          if (isLoading !== false) {
            return null;
          }

          return _react.default.createElement(Component, (0, _extends2.default)({}, ownProps, {
            isLoading: isLoading,
            data: data
          }));
        }
      }]);
      return ReadModelContainer;
    }(_react.default.PureComponent);

    var mapStateToConnectorProps = function mapStateToConnectorProps(state, ownProps) {
      var connectorOptions = mapStateToOptions(state, ownProps);

      if (connectorOptions.isReactive) {
        (0, _assign.default)(connectorOptions.resolverArgs, (0, _defineProperty2.default)({}, _constants.isReactiveArg, true));
      }

      var readModelName = connectorOptions.readModelName;
      var resolverName = (0, _get_hash.default)(connectorOptions.resolverName);
      var resolverArgs = (0, _get_hash.default)(connectorOptions.resolverArgs);
      var isReactive = connectorOptions.isReactive;

      if (isReactive) {
        (0, _assign.default)(resolverArgs, (0, _defineProperty2.default)({}, _constants.isReactiveArg, true));
      }

      var connectorMeta = state.readModels && state.readModels[_constants.connectorMetaMap] && state.readModels[_constants.connectorMetaMap]["".concat(readModelName).concat(resolverName).concat(resolverArgs)] ? state.readModels[_constants.connectorMetaMap]["".concat(readModelName).concat(resolverName).concat(resolverArgs)] : {};
      var isLoading = connectorMeta.isLoading,
          isFailure = connectorMeta.isFailure;
      var data = isLoading === false && isFailure === false ? state.readModels[readModelName][resolverName][resolverArgs] : null;
      var error = isLoading === false && isFailure === true ? connectorMeta.error : null;
      return {
        ownProps: ownProps,
        connectorOptions: connectorOptions,
        isLoading: isLoading,
        isFailure: isFailure,
        data: data,
        error: error
      };
    };

    var mapDispatchToConnectorProps = function mapDispatchToConnectorProps(dispatch) {
      return (0, _redux.bindActionCreators)({
        connectReadModel: actions.connectReadModel,
        disconnectReadModel: actions.disconnectReadModel
      }, dispatch);
    };

    var ReadModelConnector = (0, _reactRedux.connect)(mapStateToConnectorProps, mapDispatchToConnectorProps)(ReadModelContainer);
    ReadModelConnector.mapStateToOptions = mapStateToOptions;
    return (0, _connect_resolve_advanced.default)(ReadModelConnector);
  };
};

var _default = connectReadModel;
exports.default = _default;
//# sourceMappingURL=connect_read_model.js.map