"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _getIterator2 = _interopRequireDefault(require("@babel/runtime/core-js/get-iterator"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _effects = require("redux-saga/effects");

var createSagaManager = function createSagaManager() {
  var sagas = {};
  return {
    start:
    /*#__PURE__*/
    _regenerator.default.mark(function start(key, saga) {
      var _len,
          sagaArgs,
          _key,
          sagaId,
          _args = arguments;

      return _regenerator.default.wrap(function start$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!Array.isArray(sagas[key])) {
                sagas[key] = [];
              }

              for (_len = _args.length, sagaArgs = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
                sagaArgs[_key - 2] = _args[_key];
              }

              _context.next = 4;
              return _effects.fork.apply(void 0, [saga].concat(sagaArgs));

            case 4:
              sagaId = _context.sent;
              sagas[key].push(sagaId);
              return _context.abrupt("return", sagaId);

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, start, this);
    }),
    stop:
    /*#__PURE__*/
    _regenerator.default.mark(function stop(key, callback) {
      var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, sagaId;

      return _regenerator.default.wrap(function stop$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!Array.isArray(sagas[key])) {
                _context2.next = 27;
                break;
              }

              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context2.prev = 4;
              _iterator = (0, _getIterator2.default)(sagas[key]);

            case 6:
              if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                _context2.next = 13;
                break;
              }

              sagaId = _step.value;
              _context2.next = 10;
              return (0, _effects.cancel)(sagaId);

            case 10:
              _iteratorNormalCompletion = true;
              _context2.next = 6;
              break;

            case 13:
              _context2.next = 19;
              break;

            case 15:
              _context2.prev = 15;
              _context2.t0 = _context2["catch"](4);
              _didIteratorError = true;
              _iteratorError = _context2.t0;

            case 19:
              _context2.prev = 19;
              _context2.prev = 20;

              if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
              }

            case 22:
              _context2.prev = 22;

              if (!_didIteratorError) {
                _context2.next = 25;
                break;
              }

              throw _iteratorError;

            case 25:
              return _context2.finish(22);

            case 26:
              return _context2.finish(19);

            case 27:
              delete sagas[key];

              if (typeof callback === 'function') {
                callback();
              }

            case 29:
            case "end":
              return _context2.stop();
          }
        }
      }, stop, this, [[4, 15, 19, 27], [20,, 22, 26]]);
    })
  };
};

var _default = createSagaManager;
exports.default = _default;
//# sourceMappingURL=create_saga_manager.js.map