"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _effects = require("redux-saga/effects");

var _reduxSaga = require("redux-saga");

var _v = _interopRequireDefault(require("uuid/v3"));

var _get_hash = _interopRequireDefault(require("./get_hash"));

var _actions = require("./actions");

var _action_types = require("./action_types");

var _constants = require("./constants");

var _unsubscribe_read_model_topics_saga = _interopRequireDefault(require("./unsubscribe_read_model_topics_saga"));

var _create_api = require("./create_api");

var disconnectReadModelSaga =
/*#__PURE__*/
_regenerator.default.mark(function disconnectReadModelSaga(sagaArgs, action) {
  var connectionManager, sagaManager, sagaKey, queryIdMap, sessionId, readModelName, resolverName, resolverArgs, isReactive, connectionId, _connectionManager$re, removedConnections, key, queryId, stopSubscriptionResultAction;

  return _regenerator.default.wrap(function disconnectReadModelSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          connectionManager = sagaArgs.connectionManager, sagaManager = sagaArgs.sagaManager, sagaKey = sagaArgs.sagaKey, queryIdMap = sagaArgs.queryIdMap, sessionId = sagaArgs.sessionId;
          readModelName = action.readModelName, resolverName = action.resolverName, resolverArgs = action.resolverArgs, isReactive = action.isReactive;
          connectionId = "".concat((0, _get_hash.default)(resolverName)).concat((0, _get_hash.default)(resolverArgs));
          _connectionManager$re = connectionManager.removeConnection({
            connectionName: readModelName,
            connectionId: connectionId
          }), removedConnections = _connectionManager$re.removedConnections;

          if (!(removedConnections.length !== 1)) {
            _context.next = 6;
            break;
          }

          return _context.abrupt("return");

        case 6:
          key = "".concat(readModelName).concat((0, _get_hash.default)(action.resolverName)).concat((0, _get_hash.default)(action.resolverArgs));
          queryId = (0, _v.default)("".concat(key).concat(queryIdMap.get(key)).concat(sessionId), _constants.namespace);
          return _context.delegateYield(sagaManager.stop("".concat(_action_types.CONNECT_READMODEL).concat(sagaKey)), "t0", 9);

        case 9:
          _context.next = 11;
          return (0, _effects.put)((0, _actions.dropReadModelState)(readModelName, resolverName, resolverArgs));

        case 11:
          if (isReactive) {
            _context.next = 13;
            break;
          }

          return _context.abrupt("return");

        case 13:
          return _context.delegateYield((0, _unsubscribe_read_model_topics_saga.default)({
            queryId: queryId
          }), "t1", 14);

        case 14:
          if (!true) {
            _context.next = 29;
            break;
          }

          _context.next = 17;
          return (0, _effects.put)((0, _actions.stopReadModelSubscriptionRequest)(readModelName, resolverName, queryId));

        case 17:
          _context.next = 19;
          return (0, _effects.take)(function (action) {
            return (action.type === _action_types.STOP_READ_MODEL_SUBSCRIPTION_SUCCESS || action.type === _action_types.STOP_READ_MODEL_SUBSCRIPTION_FAILURE) && queryId === action.topicId;
          });

        case 19:
          stopSubscriptionResultAction = _context.sent;

          if (!(stopSubscriptionResultAction.type === _action_types.STOP_READ_MODEL_SUBSCRIPTION_SUCCESS)) {
            _context.next = 22;
            break;
          }

          return _context.abrupt("break", 29);

        case 22:
          if (!(stopSubscriptionResultAction.type === _action_types.STOP_READ_MODEL_SUBSCRIPTION_FAILURE && stopSubscriptionResultAction.error instanceof _create_api.HttpError)) {
            _context.next = 25;
            break;
          }

          // eslint-disable-next-line no-console
          console.warn('Http error: ', stopSubscriptionResultAction.error);
          return _context.abrupt("return");

        case 25:
          _context.next = 27;
          return (0, _reduxSaga.delay)(500);

        case 27:
          _context.next = 14;
          break;

        case 29:
        case "end":
          return _context.stop();
      }
    }
  }, disconnectReadModelSaga, this);
});

var _default = disconnectReadModelSaga;
exports.default = _default;
//# sourceMappingURL=disconnect_read_model_saga.js.map