"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _effects = require("redux-saga/effects");

var _actions = require("./actions");

var loadReadModelStateSaga =
/*#__PURE__*/
_regenerator.default.mark(function loadReadModelStateSaga(_ref, _ref2) {
  var api, readModelName, resolverName, resolverArgs, isReactive, queryId, _ref3, timeToLive, result;

  return _regenerator.default.wrap(function loadReadModelStateSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          api = _ref.api;
          readModelName = _ref2.readModelName, resolverName = _ref2.resolverName, resolverArgs = _ref2.resolverArgs, isReactive = _ref2.isReactive, queryId = _ref2.queryId;
          _context.prev = 2;
          _context.next = 5;
          return api.loadReadModelState({
            readModelName: readModelName,
            resolverName: resolverName,
            resolverArgs: resolverArgs,
            isReactive: isReactive,
            queryId: queryId
          });

        case 5:
          _ref3 = _context.sent;
          timeToLive = _ref3.timeToLive;
          result = _ref3.result;
          _context.next = 10;
          return (0, _effects.put)((0, _actions.loadReadModelStateSuccess)(readModelName, resolverName, resolverArgs, isReactive, queryId, result, timeToLive));

        case 10:
          _context.next = 16;
          break;

        case 12:
          _context.prev = 12;
          _context.t0 = _context["catch"](2);
          _context.next = 16;
          return (0, _effects.put)((0, _actions.loadReadModelStateFailure)(readModelName, resolverName, resolverArgs, isReactive, queryId, _context.t0));

        case 16:
        case "end":
          return _context.stop();
      }
    }
  }, loadReadModelStateSaga, this, [[2, 12]]);
});

var _default = loadReadModelStateSaga;
exports.default = _default;
//# sourceMappingURL=load_read_model_state_saga.js.map