"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _getIterator2 = _interopRequireDefault(require("@babel/runtime/core-js/get-iterator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _keys = _interopRequireDefault(require("@babel/runtime/core-js/object/keys"));

var _effects = require("redux-saga/effects");

var _actions = require("./actions");

var _action_types = require("./action_types");

var unsubscribeViewModelTopicsSaga =
/*#__PURE__*/
_regenerator.default.mark(function unsubscribeViewModelTopicsSaga(_ref) {
  var viewModels, viewModelName, aggregateIds, viewModel, eventTypes, subscriptionKeys, counter, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _ref4, aggregateId, eventType, _loop;

  return _regenerator.default.wrap(function unsubscribeViewModelTopicsSaga$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          viewModels = _ref.viewModels, viewModelName = _ref.viewModelName, aggregateIds = _ref.aggregateIds;
          viewModel = viewModels.find(function (_ref2) {
            var name = _ref2.name;
            return name === viewModelName;
          });
          eventTypes = (0, _keys.default)(viewModel.projection).filter(function (eventType) {
            return eventType !== 'Init';
          });
          subscriptionKeys = eventTypes.reduce(function (acc, eventType) {
            if (Array.isArray(aggregateIds)) {
              acc.push.apply(acc, (0, _toConsumableArray2.default)(aggregateIds.map(function (aggregateId) {
                return {
                  aggregateId: aggregateId,
                  eventType: eventType
                };
              })));
            } else if (aggregateIds === '*') {
              acc.push({
                aggregateId: '*',
                eventType: eventType
              });
            }

            return acc;
          }, []);

        case 4:
          if (!(subscriptionKeys.length > 0)) {
            _context2.next = 40;
            break;
          }

          counter = subscriptionKeys.length;
          _iteratorNormalCompletion = true;
          _didIteratorError = false;
          _iteratorError = undefined;
          _context2.prev = 9;
          _iterator = (0, _getIterator2.default)(subscriptionKeys);

        case 11:
          if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
            _context2.next = 19;
            break;
          }

          _ref4 = _step.value;
          aggregateId = _ref4.aggregateId, eventType = _ref4.eventType;
          _context2.next = 16;
          return (0, _effects.put)((0, _actions.unsubscribeTopicRequest)(eventType, aggregateId));

        case 16:
          _iteratorNormalCompletion = true;
          _context2.next = 11;
          break;

        case 19:
          _context2.next = 25;
          break;

        case 21:
          _context2.prev = 21;
          _context2.t0 = _context2["catch"](9);
          _didIteratorError = true;
          _iteratorError = _context2.t0;

        case 25:
          _context2.prev = 25;
          _context2.prev = 26;

          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }

        case 28:
          _context2.prev = 28;

          if (!_didIteratorError) {
            _context2.next = 31;
            break;
          }

          throw _iteratorError;

        case 31:
          return _context2.finish(28);

        case 32:
          return _context2.finish(25);

        case 33:
          _loop =
          /*#__PURE__*/
          _regenerator.default.mark(function _loop() {
            var unsubscribeResultAction;
            return _regenerator.default.wrap(function _loop$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return (0, _effects.take)( // eslint-disable-next-line no-loop-func
                    function (action) {
                      return (action.type === _action_types.UNSUBSCRIBE_TOPIC_SUCCESS || action.type === _action_types.UNSUBSCRIBE_TOPIC_FAILURE) && subscriptionKeys.find(function (key) {
                        return key.aggregateId === action.topicId && key.eventType === action.topicName;
                      });
                    });

                  case 2:
                    unsubscribeResultAction = _context.sent;

                    if (unsubscribeResultAction.type === _action_types.UNSUBSCRIBE_TOPIC_SUCCESS) {
                      subscriptionKeys = subscriptionKeys.filter(function (key) {
                        return !(key.aggregateId === unsubscribeResultAction.topicId && key.eventType === unsubscribeResultAction.topicName);
                      });
                    }

                    counter--;

                  case 5:
                  case "end":
                    return _context.stop();
                }
              }
            }, _loop, this);
          });

        case 34:
          if (!(counter > 0)) {
            _context2.next = 38;
            break;
          }

          return _context2.delegateYield(_loop(), "t1", 36);

        case 36:
          _context2.next = 34;
          break;

        case 38:
          _context2.next = 4;
          break;

        case 40:
        case "end":
          return _context2.stop();
      }
    }
  }, unsubscribeViewModelTopicsSaga, this, [[9, 21, 25, 33], [26,, 28, 32]]);
});

var _default = unsubscribeViewModelTopicsSaga;
exports.default = _default;
//# sourceMappingURL=unsubscribe_view_model_topics_saga.js.map